#!/usr/bin/php
<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99d                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                             evcz@evcz.tk                             *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                   comments and suggestions here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/

//damaster added logging to the app and made it run from cmd line

//control if the find_baddies tools is locked
if(file_exists("FIND_BADDIES.LOCK")){
	die("Find Baddies not active, before run it you need to delete the *maintain/FIND_BADDIES.LOCK* file");
	exit();
}

//no time limit ;)
set_time_limit(0); 

require_once("functions.php");
require_once("config.php");

//This should be ran from a command line
//you will have to chmod this file to 777
//for it to work.

if($ipblocker_config['forum_app_type'] == "ipb_users"){
	//ipb settings
	$baddies_table_name = "ibf_members";
	$baddies_ip_column = "ip_address";
	$baddies_id_column = "id";
	$baddies_user_column = "name";
}
elseif($ipblocker_config['forum_app_type'] == "vb_users"){
	//vbulletin settings
	$baddies_table_name = "user";
	$baddies_ip_column = "ipaddress";
	$baddies_id_column = "userid";
	$baddies_user_column = "username";
}
if($ipblocker_config['forum_app_type'] == "ipb_posts"){
	//ipb settings
	$baddies_table_name = "ibf_posts";
	$baddies_ip_column = "ip_address";
	$baddies_id_column = "pid";
	$baddies_user_column = "author_name";
}
elseif($ipblocker_config['forum_app_type'] == "vb_posts"){
	//vbulletin settings
	$baddies_table_name = "post";
	$baddies_ip_column = "ipaddress";
	$baddies_id_column = "userid";
	$baddies_user_column = "username";
}
elseif($ipblocker_config['forum_app_type'] == "phpbb_posts"){
	//pbpbb 2.0.x settings (poster_id instead of post_username that's generally is empty)
	$baddies_table_name = "phpbb_posts";
	$baddies_ip_column = "poster_ip";
	$baddies_id_column = "post_id";
	$baddies_user_column = "poster_id";
}
//If you are using another application set these data according to your table layout
elseif($ipblocker_config['forum_app_type'] == "myapp"){
	//custom settings
	//users table name
	$baddies_table_name = "user";
		//users ip column
		$baddies_ip_column = "ipaddress";
		//users ip column
		$baddies_id_column = "userid";
		//users username column
		$baddies_user_column = "username";
}
else{
	die("unsupported application");
}

//start timer
$mtime = microtime();
$mtime = explode(" ",$mtime);
$mtime = $mtime[1] + $mtime[0];
$start_time = "".$mtime;
//timer

//connect to mysql
ipblocker_connect();

//select forum db
mysql_select_db($ipblocker_config['find_baddies_db_name']);

//read ALL the ips
//$baddies_result = mysql_query("SELECT ".$baddies_ip_column.",".$baddies_id_column.",".$baddies_user_column." FROM `".$baddies_table_name."` WHERE ".$baddies_ip_column." > 0", $ipblocker_config['connection_link']) or die(mysql_error());
$baddies_result = mysql_query("SELECT ".$baddies_ip_column.",".$baddies_id_column.",".$baddies_user_column." FROM `".$baddies_table_name."` WHERE 1", $ipblocker_config['connection_link']) or die(mysql_error());

//re-select ipblocker db
mysql_select_db($ipblocker_config['db_name']);

//inizialize stats counters
$i = 0;
$bads = 0;
$ignored = 0;

//create log filename
$logFileName = $ipblocker_config['fullpathLogName']."baddies_".date("Y")."".date("m")."".date("d").".log";

//open/create the log file
$fp = @fopen ($logFileName, "a") or die("Unable to open/create the logging file! cannot proceed");

//print info about type of check
$string = "Check routine loaded: ".$ipblocker_config['forum_app_type']."\n";
echo $string;
@fwrite($fp, $string) or die("Unable to write the logging file! cannot proceed");

//user_ip array VS ipblocker table
while($data = mysql_fetch_array($baddies_result)){
	$ip = "".$data[$baddies_ip_column]."";

	//phpbb ip decoding internal routine
	if($ipblocker_config['forum_app_type'] == "phpbb_posts"){
		$temp_ip = explode('.', chunk_split($ip, 2, '.'));
		$ip = hexdec($temp_ip[0]). '.' . hexdec($temp_ip[1]) . '.' . hexdec($temp_ip[2]) . '.' . hexdec($temp_ip[3]);
	}
	
	if(($ipblocker_config['find_baddies_skip_fakes'] && ((0<$ip && $ip<16777215) || (167772160<$ip && $ip<184549375) || (3232235520<$ip && $ip<3232301055) || (4026531840<$ip && $ip<4294967295) || (2130706432<$ip && $ip<2147483647) || (2886729728<$ip && $ip<2887778303))) || $ip == $ipblocker_config['find_baddies_reset_ip'])
		$ignored++;
	else{
		$ipblocker_query_result = mysql_query("SELECT rangename FROM ".$ipblocker_config['db_table_name']." WHERE start <= '".sprintf("%u", ip2long($ip))."' AND end >= '".sprintf("%u", ip2long($ip))."' LIMIT 1", $ipblocker_config['connection_link']) or die(mysql_error());
		if(mysql_num_rows($ipblocker_query_result) > 0){
			$ipblocker_query_result = @mysql_fetch_array($ipblocker_query_result);
			$string = "Range: ".$ipblocker_query_result['rangename']." ID: ".$data[$baddies_id_column]." IP: ".$ip." User: ".$data[$baddies_user_column]."\n";
			echo $string;
			@fwrite($fp, $string) or die("Unable to write the logging file! cannot proceed");
			$bads++;
		}
	}
	$i++;
}

//disconnect from mysql
ipblocker_disconnect();

//end timer
$mtime = microtime();
$mtime = explode(" ",$mtime);
$mtime = $mtime[1] + $mtime[0];
$end_time = $mtime;
//timer

@fwrite($fp, "\n\n");

//create the FIND_BADDIES.LOCK file so nobody can run find_buddies.php whith the intention to crash your server ;)
$string = "Unable to lock find_buddies.php! ... i'll try to delete it...\n";
$lock = @fopen ("FIND_BADDIES.LOCK", "a");
@fclose($lock);

//delete find_baddies.php file if lock procedure fails
if (!file_exists("FIND_BADDIES.LOCK")){
	$string = "Unable to lock find_buddies.php! ... i'll try to delete it...\n";
	echo $string;
	@fwrite($fp, $string);
	//delete find_baddies.php file
	unlink("find_baddies.php");
	if (file_exists("find_baddies.php")){
		$string = "I wasn't able to delete the find_baddies.php file, *delete it manually*\n";
		echo $string;
		@fwrite($fp, $string);
	}
	else
		$string = "The find_baddies.php file has been deleted\n";
		echo $string;
		@fwrite($fp, $string);
}
else{
	$string = "The find_baddies.php now is locked, to run it again you need to deleted the lock file: maintain/INSTALL.LOCK\n";
	echo $string;
	@fwrite($fp, $string);
}

$string = "Process completed in ".round($end_time-$start_time,3)." seconds\n".$i." entries controlled, ".$ignored." entries ignored, ".$bads." bads entries detected\nAverage control time: ".round(((round($end_time-$start_time,4))/($i)),4)."\n";
echo $string;
@fwrite($fp, $string) or die("Unable to write the logging file! cannot proceed");

//close the log file
@fclose($fp) or die("Unable to close the logging file! cannot proceed");

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>